import { createContext, useContext } from "react";
import { isLocaleRTL } from "./isLocaleRTL.mjs";
import { jsx } from "react/jsx-runtime";
const defaultLocale = {
    direction: "ltr",
    locale: "en-US"
  },
  LocaleContext = createContext(defaultLocale);
function getLocaleDirection(locale) {
  return isLocaleRTL(locale) ? "rtl" : "ltr";
}
function LocaleProvider(props) {
  const {
    direction,
    locale,
    children
  } = props;
  return direction || locale ? /* @__PURE__ */jsx(LocaleContext.Provider, {
    value: {
      direction: locale ? getLocaleDirection(locale) : direction,
      locale
    },
    children
  }) : children;
}
function useLocaleContext() {
  return useContext(LocaleContext);
}
export { LocaleProvider, getLocaleDirection, useLocaleContext };